/*==============================================================
  global variables.h
  used with spectrum.cpp
  intialization of general purpose, system, and control registers
  written by z80man
  ==============================================================*/

unsigned int R[16];      //general purpose register array R0-R15
unsigned int R_banked[8]; //banked register array R0_BANK-R7_BANK
unsigned int SR,GBR,VBR,MACH,MACL,PR,PC,SSR,SPC;
struct SR0 // bit struct for system register
{
	unsigned int dummy0:4;
	unsigned int RC0:12;
	unsigned int dummy1:4;
	unsigned int DMY0:1;
	unsigned int DMX0:1;
	unsigned int M0:1;
	unsigned int Q0:1;
	unsigned int I0:4;
	unsigned int RF10:1;
	unsigned int RF00:1;
	unsigned int S0:1;
	unsigned int T0:1;
};
struct savedSR0 // bit struct for saved system register
{
	unsigned int saveddummy0:4;
	unsigned int savedRC0:12;
	unsigned int saveddummy1:4;
	unsigned int savedDMY0:1;
	unsigned int savedDMX0:1;
	unsigned int savedM0:1;
	unsigned int savedQ0:1;
	unsigned int savedI0:4;
	unsigned int savedRF10:1;
	unsigned int savedRF00:1;
	unsigned int savedS0:1;
	unsigned int savedT0:1;
};
#define M ((*(struct SR0 *)(&SR)).M0) //defintion for SR0
#define Q ((*(struct SR0 *)(&SR)).Q0)
#define S ((*(struct SR0 *)(&SR)).S0)
#define T ((*(struct SR0 *)(&SR)).T0)
#define RF1 ((*(struct SR0 *)(&SR)).RF10)
#define RF0 ((*(struct SR0 *)(&SR)).RF00)

struct middle_byte                       //creates a bit feld for reading the middle byte of an instruction
{
	unsigned char half_byte1:4;
	unsigned char half_byte2:4;
};
unsigned char low_byte;   //creates low byte of instruction

#define half_byte1 middle_byte.half_byte1
#define half_byte2 middle_byte.half_byte2

	