/*=============================================
  instruction set.h
  used with spectrum.cpp
  contains function for each SH3 instruction
  written by z80man
  =============================================*/

void ADD() //ADD Rm,Rn
{
	R[two] += R[three];
	PC += 2;
}
void MOVLi() // MOV.L @(disp,PC),Rn
{
	unsigned int n = half_byte1;
	unsigned int d = low_byte;
	R[n] = readmemory_long(d * 4 + PC);
	PC += 2;
	return;
}
void MOVr()
{
	unsigned int n = half_byte1;
	unsigned int m = half-byte2;
	R[n] = R[m];
	PC += 2;
	return;
}
void MOVLim()
{ 
	unsigned int n = half_byte1;
	unsigned int m = half-byte2;
	R[n] = readmemory_long(R[m]);
	PC += 2;
	return;
}
void MOVin()
{
	unsigned int n = half_byte1;
	unsigned int m = half-byte2;
	writememory_long(R[n], R[m]);
	PC += 2;
	return;
}
void MOVLpush()
{
	unsigned int n = half_byte1;
	unsigned int m = half-byte2;
	R[n] -= 4;
	writememory_long(R[n], R[m]);
	PC += 2;
	return;
}
void MOVLpop()
{
	unsigned int n = half_byte1;
	unsigned int m = half-byte2;
	R[n] = readmemory_long(R[m];
	R[m] += 4;
	PC += 2;
	return;
}
void CMPEQ()
{
	unsigned int n = half_byte1;
	unsigned int m = half-byte2;
	if (R[n] == R[m]) T = 1;
	else T = 0;
	PC += 2;
	return;
}
void DT()
{
	unsigned int n = half_byte1;
	R[n]--;
	if (R[n] == 0) T = 1;
	else T = 0;
	PC += 2;
	return;
}
	
	
	
	
	